//
// PermissionsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PermissionsAPI {
    /**
     Grant the permission to the role with provided ID

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func grantRolePermission(body: PermissionCreate, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        grantRolePermissionWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Grant the permission to the role with provided ID
     - POST /api/v1/permissions
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func grantRolePermissionWithRequestBuilder(body: PermissionCreate) -> RequestBuilder<APIResponseStatusOK> {
        let path = "/api/v1/permissions"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Revoke the permission from the role with provided ID

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func revokeRolePermission(body: Permission, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        revokeRolePermissionWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Revoke the permission from the role with provided ID
     - DELETE /api/v1/permissions
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func revokeRolePermissionWithRequestBuilder(body: Permission) -> RequestBuilder<APIResponseStatusOK> {
        let path = "/api/v1/permissions"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
